import { BaseRoute } from './BaseRoute';
import { Type, IContainer, AsyncParamProvider, Token } from 'tsioc';
import { IContext } from '../IContext';
import { Next } from '../util';
import { RouteMetadata } from '../decorators';
import { RequestMethod } from '../RequestMethod';
export declare class ControllerRoute extends BaseRoute {
    private controller;
    constructor(route: string, controller: Type<any>);
    options(container: IContainer, ctx: IContext, next: Next): Promise<any>;
    navigating(container: IContainer, ctx: IContext): Promise<any>;
    invokeOption(ctx: IContext, container: IContainer, next: Next): Promise<any>;
    invoke(ctx: IContext, container: IContainer, decorator: Function, provider: (meta: RouteMetadata, params: Token<any>[], ctrl: any) => AsyncParamProvider[]): Promise<void>;
    protected getDecoratorByMethod(method?: string | RequestMethod): Function;
    protected createProvider(container: IContainer, meta: RouteMetadata, params: Token<any>[], ctrl: any, ctx: IContext): AsyncParamProvider[];
    protected isBaseType(p: any): boolean;
    protected isRestUri(uri: string): boolean;
    protected getRouteMetaData(ctx: IContext, container: IContainer, decorator: Function): RouteMetadata;
}
